/*
 * Copyright 2011 qqybk2l.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ch.lambdaj.function.matcher;

import org.hamcrest.Description;
import org.hamcrest.Factory;

/**
 *
 * @author Dietrich Schulten
 */
public class NotNullOrEmptyMatcher<T> extends LambdaJMatcher<T> {

    public boolean matches(Object item) {
        return item != null && item.toString().length() != 0;
    }

    @Override
    public void describeTo(Description description) {
        description.appendText("not null or empty");
    }

    /**
     * Creates an hamcrest matcher that is evalued to true accordingly to the value of the passed argument
     * @return The hamcrest matcher that is evalued to true accordingly to the value of the passed argument
     */
    @Factory
    public static <T> NotNullOrEmptyMatcher<T> notNullOrEmpty() {
        return new NotNullOrEmptyMatcher<T>();
    }
}
